﻿Type=Class
Version=5.02
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@
'Class module
Sub Class_Globals
    Dim BTAdmin         As BluetoothAdmin
    Dim BTMacAddress    As String

    Dim BTConnection    As Serial
    Dim BTPrinter       As TextWriter

    Dim BTConnected     As Boolean

    Dim BTNotify        As String
    Dim BTNotifyRoutine As String
	
    Dim PCL3    		As cPCL3

End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize(ParentNotify As String, ParentRoutine As String)

    BTNotify        = ParentNotify
    BTNotifyRoutine = ParentRoutine

    BTConnected     = False
    BTMacAddress    = ""

    BTAdmin.Initialize("BlueTooth")
    BTConnection.Initialize("BTPrinter")
End Sub


Sub BTPrinter_Connected(Connected As Boolean)
    BTConnected = Connected
	
	If  BTConnected Then
		Try
		    BTPrinter.Initialize(BTConnection.OutputStream)
	    	PCL3.Initialize(BTConnection.OutputStream)
	    Catch
	        Log(LastException.Message)
	    End Try
	End If
	
    CallSub2(BTNotify, BTNotifyRoutine, BTConnected)
End Sub

Sub Connect(MacAddress As String)

    Dim PairedDevices   As Map
    Dim L               As List
    Dim Res             As Int
    Dim EntryFound      As Int


    BTMacAddress = MacAddress


    PairedDevices.Initialize


    Try
        PairedDevices = BTConnection.GetPairedDevices
    Catch
        BTPrinter.Close
        BTConnection.Disconnect
    End Try


    If PairedDevices.Size = 0 Then
        Msgbox("Error Connecting to Printer - No printers found", "BlueTooth Printer Connect")
        Return
    End If


    EntryFound = -1

    L.Initialize

    For i = 0 To PairedDevices.Size - 1
        Log("GetKeyAt:" &PairedDevices.GetKeyAt(i) &"  Get:" &PairedDevices.Get(i))

        L.Add(PairedDevices.GetKeyAt(i))

        If BTMacAddress.Length <> 0 And PairedDevices.Get(PairedDevices.GetKeyAt(i)) = BTMacAddress Then
           EntryFound = i
           Exit
        End If
    Next

    If EntryFound == -1 Then
       Res = InputList(L, "Choose device", -1)

       If Res = DialogResponse.CANCEL Then
          Return
       End If
    Else
       Res = EntryFound
    End If

    Log("Selected Device:" &PairedDevices.Get(L.Get(Res)) &"  L.Get(Res): " &L.Get(Res))
	
    BTConnection.Connect(PairedDevices.Get(L.Get(Res)))

End Sub

Sub Close
    If BTConnected = False Then Return

    If BTPrinter.IsInitialized Then
       BTPrinter.Flush
       BTPrinter.Close
    End If

    BTConnection.Disconnect
    BTConnected = False
End Sub

Sub IsConnected As Boolean                                             :  
Return BTConnected                                : 
End Sub

Sub StartJob As Boolean                                                :  
Return BTConnected                                : 
End Sub

Sub EndJob                                                             :  
If BTConnected Then BTPrinter.Flush               : 
End Sub
